#include <stdio.h>
#include <math.h>
int main(int argc,char**argv)
{
	// mintavételi freki a szimulációhoz
	int fs=10e6;

	// szinuszmodulált USB jel: moduláló freki 1000 Hz, vivő: 100 kHz
	int ftx=(100000+1000);

	// vételi vivőfreki
	int frx=100000;

	// RC aluláteresztő szűrők 3 kHz-es törésponti frekivel
	double AA=(1.0/fs)/( 1.0/2.0/M_PI/3000 + 1.0/fs );
	double BB=(1.0-AA);

	// LPF bemenei minták
	double in[4]={0,0,0,0};

	// LPF kimenei minták + az előző minták
	double out[4]={0,0,0,0};
	double outmem[4]={0,0,0,0};

	unsigned long N=10000;
	unsigned long t=0;

	int sw=0;
	double tx;
	double rx=0,rxm=0;
	double omtx=2.0*M_PI*ftx/fs;
	double omrx=2.0*M_PI*frx/fs;
	int i;

	FILE *f;
	f=fopen("samples.txt","wt");
	if(f==NULL){
		printf("error open output file\n");
		return -1;
	}

	while(t<N){
		// az adott szinuszjel minták
		tx=cos(omtx*t);

		// a vételi lekeverés 4 szeres kapcsolóvezérléssel
		rx=cos(4.0*omrx*t);
		if( (rxm<=0) && (rx>0) ) sw = (sw + 1) % 4;
		rxm=rx;

		// mintavétel
		for(i=0;i<4;i++) in[i]=0;
		in[sw]=tx;

		// numerikus RC-LPF léptetés
		for(i=0;i<4;i++){
			out[i]=AA*in[i]+BB*outmem[i];
			outmem[i]=out[i];
		}

		fprintf(f,"%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\n",tx,in[0],in[1],in[2],in[3],out[0],out[1],out[2],out[3]);

		t++;
	}

	fclose(f);
	return 0;
}
